import { PriorityQueue, PriorityQueueOption } from "./PriorityQueue";
/**
 * An implementation of Binary Heap.
 */
export declare class BinaryHeap<T> extends PriorityQueue<T> {
    collection: T[];
    static from<U>(array: U[], option?: PriorityQueueOption<U>): BinaryHeap<U>;
    clear(): void;
    toArray(): T[];
    readonly length: number;
    top(): T;
    pop(): T;
    push(value: T): void;
    merge(other: PriorityQueue<T>): void;
    isEmpty(): boolean;
}
