import { PriorityQueue, PriorityQueueOption } from "./PriorityQueue";
declare type Node<T> = {
    value: T;
    left: Node<T> | null;
    right: Node<T> | null;
};
/**
 * An implementation of Skew Heap.
 */
export declare class SkewHeap<T> extends PriorityQueue<T> {
    root: Node<T> | null;
    _length: number;
    static from<U>(array: U[], option?: PriorityQueueOption<U>): SkewHeap<U>;
    clear(): void;
    readonly length: number;
    push(val: T): void;
    top(): T;
    pop(): T;
    merge(other: PriorityQueue<T>): void;
    toArray(): T[];
    isEmpty(): boolean;
}
export {};
