"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.numericGreaterFirst = numericGreaterFirst;
exports.dictOrderGreaterFirst = dictOrderGreaterFirst;
exports.defaultComparator = void 0;

/**
 * A signature definition of comparator.
 * This type has same to an argument of `Array#sort`.
 */

/**
 * A type of comparator's result.
 */
function numericGreaterFirst(a, b) {
  return a > b ? 1 : a < b ? -1 : 0;
}

function dictOrderGreaterFirst(_a, _b) {
  var a = _a.toString();

  var b = _b.toString();

  return a > b ? 1 : a < b ? -1 : 0;
}

var defaultComparator = dictOrderGreaterFirst;
exports.defaultComparator = defaultComparator;