/**
 * A signature definition of comparator.
 * This type has same to an argument of `Array#sort`.
 */
export declare type Comparator<T> = (a: T, b: T) => ComparatorResult;
/**
 * A type of comparator's result.
 */
export declare type ComparatorResult = 1 | 0 | -1 | number;
export declare function numericGreaterFirst(a: number, b: number): ComparatorResult;
export declare function dictOrderGreaterFirst(_a: {}, _b: {}): ComparatorResult;
export declare const defaultComparator: typeof dictOrderGreaterFirst;
